unit xdatalogu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, ComCtrls, StdCtrls, LMessages, Menus, Windows, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    btAddTrack: TBitBtn;
    btComment: TBitBtn;
    btClose: TBitBtn;
    cbTimebase: TComboBox;
    ckSmartSlide: TCheckBox;
    ckScrLock: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lSample: TLabel;
    lCursor: TLabel;
    lComment: TLabel;
    lSamples: TLabel;
    lTime: TLabel;
    lTrZoom: TLabel;
    lZoom: TLabel;
    dlgOpen: TOpenDialog;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    mnConsole: TMenuItem;
    mnHelp: TMenuItem;
    mnExit: TMenuItem;
    mnClear: TMenuItem;
    mnSave: TMenuItem;
    mnLoad: TMenuItem;
    mnFile: TMenuItem;
    pbMain: TPaintBox;
    Panel1: TPanel;
    pnTrackBts: TPanel;
    Panel3: TPanel;
    dlgSave: TSaveDialog;
    sbRun: TSpeedButton;
    sbPaws: TSpeedButton;
    sbStop: TSpeedButton;
    tbTOffset: TTrackBar;
    tmRefresh: TTimer;
    tmPoll: TTimer;
    tbZoom: TTrackBar;
    tbOffset: TTrackBar;
    tbTZoom: TTrackBar;
    procedure btCommentClick(Sender: TObject);
    procedure btTrackMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ckScrLockClick(Sender: TObject);
    function  LoadFile(st: string): boolean;
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure BtTrackClick(Sender: TObject);
    procedure drawcursor;
    procedure FormShow(Sender: TObject);
    procedure mnClearClick(Sender: TObject);
    procedure mnConsoleClick(Sender: TObject);
    procedure mnExitClick(Sender: TObject);
    procedure mnHelpClick(Sender: TObject);
    procedure pbMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure pbMainMouseEnter(Sender: TObject);
    procedure pbMainMouseLeave(Sender: TObject);
    function  FindSample(var sam: integer; X, Y: Integer): integer;
    procedure pbMainMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure pbMainMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure rbTrackSelClick(Sender: TObject);
    procedure cbTimebaseSelect(Sender: TObject);
    function  CreateTRButton(ez: integer): TBitBtn;
    procedure btAddTrackClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbMainPaint(Sender: TObject);
    procedure sbPawsClick(Sender: TObject);
    procedure sbRunClick(Sender: TObject);
    procedure sbStopClick(Sender: TObject);
    procedure tbTZoomChange(Sender: TObject);
    procedure tbZoomChange(Sender: TObject);
    procedure tmPollTimer(Sender: TObject);
    procedure tmRefreshTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

  TTrMyButton	= class(TBitBtn)
    procedure HandleRelease(var Msg: TLMessage); message CM_RELEASE;
  end;

var
  Form1: TForm1;

implementation
Uses Synaser, datalogtrack, aboutu, consleu;
{$R *.lfm}

(*
 		Struttura dati per contenere i valori

  Fino a 16 tracce; ogni traccia ha una serie di parametri e un puntatore
  a un array di float. Quando i dati diventano troppi, viene allocata
  maggiore memoria per tutti. Parla solo con EZ-Red, ma si possono mettere
  marcatori.
*)


var
  wasadding		: boolean = false;		// if pressed "add new track", to delete it if dialog box cancelled
  showcross		: boolean = false;
  ocrossx		: integer = -1;
  ocrossy		: integer = 0;
  wasstopped	: boolean = true;
  commerror		: boolean = false;

  comments		: TStringList;
  CommLines		: TList;
  viscomment	: integer = -1;			// active comment
  locksamples	: integer;

const
  TimeBases	: array[0..11] of integer = (
    50, 75, 100, 150, 200, 333, 500, 750,		// ms
    1000, 2000, 5000, 10000);					// sec

{ TForm1 }


procedure TForm1.cbTimebaseSelect(Sender: TObject);
begin
  timebase := TimeBases[cbTimebase.ItemIndex];
  tmPoll.Interval := timebase;
end;

procedure TTrMyButton.HandleRelease(var Msg: TLMessage);
begin
  free
end;

procedure TForm1.BtTrackClick(Sender: TObject);
var
  ez	: integer;

begin
  ez := TButton(sender).tag;
  TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(ez)) ).Checked := true;

  curez := ez;
  commerror := false;
  with fmTrack do begin
    Prepare;
  end;
  if (fmtrack.ShowModal=mrIgnore) or wasadding and (fmtrack.ShowModal=mrCancel) then begin
	// eliminare
    tracks[ez].comnum := 0;
    if not wasadding then datamodi := true;
    // pnTrackBts.FindChildControl('bttr'+inttostr(ez)).Free;
    PostMessage( TBitBtn(pnTrackBts.FindChildControl('bttr'+inttostr(ez))).Handle, CM_RELEASE, 0, 0);
    pnTrackBts.FindChildControl('cktr'+inttostr(ez)).Free;
    pnTrackBts.FindChildControl('rbtr'+inttostr(ez)).Free;
    OpenPorts;
    exit
  end;
  TButton(sender).Caption := tracks[ez].name;
  TCheckBox( pnTrackBts.FindChildControl('cktr'+inttostr(ez)) ).Color := tracks[ez].scrcolor;
  TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(ez)) ).Color := tracks[ez].scrcolor;
  OpenPorts;
  tbTZoomChange(NIL);
end;

procedure TForm1.drawcursor;
begin
  // if not showcross then exit;
  if ocrossx=-1 then exit;
  pbMain.Canvas.Pen.Mode := pmXor;
  pbMain.Canvas.Pen.color:= clGray;
  pbMain.Canvas.moveto(0,ocrossy);  pbMain.Canvas.LineTo(pbMain.Width,ocrossy);
  pbMain.Canvas.moveto(ocrossx,0);  pbMain.Canvas.LineTo(ocrossx,pbMain.height);
  pbMain.Canvas.Pen.Mode := pmCopy;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if FileExists('auto.xdlog')
    then LoadFile('auto.xdlog');
end;

procedure TForm1.mnClearClick(Sender: TObject);
var
  i		: integer;

begin
  if sender<>NIL then if datamodi then begin
    if Application.MessageBox('Really discard all data?', 'Xdatalogger', MB_YESNO or MB_DEFBUTTON2)<>IDYES then exit;
  end;

  commerror := false;
  if samples<>0 then datamodi := true;
  for i := 1 to High(tracks) do with tracks[i] do begin
    if arylen<>0 then Freemem(data);
    data := NIL;
  end;
  samples := 0;			// numero di punti presenti
  locksamples := 0;
  arylen  := 0;

  CommLines.Clear;
  comments.Clear;
end;

procedure TForm1.mnConsoleClick(Sender: TObject);
var
  ez	: integer;
  rb	: TRadioButton;

begin
  for ez := 1 to 16 do begin
    rb := TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(ez)) );
    if rb=NIL then continue;
    if not rb.Checked then continue;
    theserial := tracks[ez].comport;
    if theserial=NIL then OpenPorts;
    theserial := tracks[ez].comport;
    break
  end;
  if theserial=NIL then begin
    Application.MessageBox('A properly configured track is needed','Xdatalogger');
    exit;
  end;

  fmConsole.prepare;
  fmConsole.show;
end;

procedure TForm1.mnExitClick(Sender: TObject);
begin
  if datamodi then begin
    if Application.MessageBox('Exit with unsaved data?', 'Xdatalogger', MB_YESNO or MB_DEFBUTTON2)<>IDYES then exit;
  end;
  close
end;

procedure TForm1.mnHelpClick(Sender: TObject);
begin
  fmAbout := TfmAbout.Create(Application);
  fmAbout.showmodal;
  fmAbout.free
end;

procedure TForm1.pbMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then begin
    if showcross then if ocrossx>=0 then drawcursor;	// clear old cursor
    showcross := not showcross;
    if showcross
      then pbMain.Cursor := crNone
      else pbMain.Cursor := crCross;
    if showcross then drawcursor;
  end
end;

procedure TForm1.pbMainMouseEnter(Sender: TObject);
begin
  lCursor.Visible := true;
  if not showcross then exit;
end;

procedure TForm1.pbMainMouseLeave(Sender: TObject);
begin
  lCursor.Visible := false;
  lSample.Visible := false;
  if not showcross then exit;
  if ocrossx>=0 then drawcursor;	// clear old cursor
  ocrossx := -1;
end;

const
  pixxsampl		: array[0..5] of integer = (8, 6, 4, 3, 2, 1);

function timedesc(vl: real): string;
var
  o2	: integer;
  st	: string;

begin
  o2 := trunc(vl/(24*60*60*1000)); // days
  st := format('%d days, %2.2f h', [o2, (vl-o2*24*60*60*1000) / 60 / 60 / 1000]);
  if vl<24*60*60*1000 then st := format('%2.2f h', [vl / 60 / 60 / 1000]);
  if vl<60*60*1000 then st := format('%2.2f m', [vl / 60 / 1000]);
  if vl<60*1000 then st := format('%2.2f s', [vl / 1000]);
  if vl<1000 then st := format('%d ms', [round(vl)]);
  result := st
end;

function TForm1.FindSample(var sam: integer; X, Y: Integer): integer;
var
  i		: integer;
  rz	: real;
  vl	: real;
  msam	: integer;
  ck	: TCheckBox;

begin
  // find sample num and track
  result := 0;	// not found
  if tbZoom.Position>=tbZoom.max-5
    then rz := pixxsampl[tbZoom.max-tbZoom.Position]
    else rz := tbZoom.Position / (tbZoom.max-5);

  if ckScrLock.checked
    then msam := locksamples
    else msam := samples;

  sam := round(msam*tbOffset.Position/tbOffset.max+x/rz);
  if (sam<1) or (sam>msam) then exit;
  for i := 1 to high(tracks) do with tracks[i] do begin
    if comnum<1 then continue;
    ck := TCheckBox( pnTrackBts.FindChildControl('cktr'+inttostr(i)) );
    if ck=NIL then continue;
    if not ck.Checked then continue;

	vl := data^[sam]*scrzom+scrofs;
    if abs(round(vl)-y)<12 then begin
      result := i;
      exit
    end
  end
end;

procedure TForm1.pbMainMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  rz	: real;
  vl	: real;
  i,sam	: integer;
  com	: integer;
  cur	: integer;
  toll	: integer;
  msam	: integer;

begin
  if showcross then begin
    if ocrossx>=0 then drawcursor;	// clear old cursor
    ocrossx := x;
    ocrossy := y;
    drawcursor
  end;
  ocrossx := x;
  ocrossy := y;

  if ckScrLock.checked
    then msam := locksamples
    else msam := samples;

  // show cursor time
  if tbZoom.Position>=tbZoom.max-5
    then rz := pixxsampl[tbZoom.max-tbZoom.Position]
    else rz := tbZoom.Position / (tbZoom.max-5);
  vl := msam*tbOffset.Position/tbOffset.max;
  vl := (vl+x/rz)*timebase;
  lCursor.Caption := 'Cursor: '+timedesc(vl);

  viscomment := -1;

  // show sample data, if found
  i := FindSample(sam, x, y);
  if i<1 then lSample.Visible := false else with tracks[i] do begin
	vl := data^[sam]*scrzom+scrofs;
    if abs(round(vl)-y)<12 then begin
      lSample.font.Color := scrcolor;
      lSample.Caption := format('%3.2f', [data^[sam]]);
      lSample.Left := X + pbMain.left+12;
      if vl<y
        then lSample.top  := Y + pbMain.top-8+8
        else lSample.top  := Y + pbMain.top-8-8;
      lSample.Visible := true;
    end
  end;

  // if not sample data, perhaps comment
  if lSample.Visible=false then begin
    sam := round(msam*tbOffset.Position/tbOffset.max+x/rz);
    toll := round(8/rz);
    // show comments, if any
    for cur := 0 to CommLines.Count-1 do begin
      com := integer(CommLines[cur]);
      if com <= sam-toll then continue;	// too much to the left
      if com > sam+toll then continue;
      lSample.font.Color := clWhite;
      lSample.Caption := comments[cur];
      lSample.Left := X + pbMain.left+12;
      lSample.top  := Y + pbMain.top-12;
      lSample.Visible := true;
      viscomment := cur;
      break
    end
  end
end;

procedure TForm1.pbMainMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  rz,rza: real;
  i		: integer;

begin
  Handled := true;

  if ssCtrl in Shift then begin
    if tbZoom.Position>=tbZoom.max-5
      then rz := pixxsampl[tbZoom.max-tbZoom.Position]
      else rz := tbZoom.Position / (tbZoom.max-5);

    if WheelDelta>0 then begin
      tbZoom.Position := tbZoom.Position+1;
    end else begin
      tbZoom.Position := tbZoom.Position-1;
    end;
    if tbZoom.Position>=tbZoom.max-5
      then rza := pixxsampl[tbZoom.max-tbZoom.Position]
      else rza := tbZoom.Position / (tbZoom.max-5);

    tbOffset.Position := tbOffset.Position + round( (MousePos.x/rz-MousePos.x/rza) *1000/samples);

  end else begin
    if WheelDelta>0 then begin
      for i := 1 to high(tracks) do begin
        if tracks[i].comnum=0 then continue;
        tracks[i].scrofs := tracks[i].scrofs+pbMain.Height div 16;
      end;
    end else begin
      for i := 1 to high(tracks) do begin
        if tracks[i].comnum=0 then continue;
        tracks[i].scrofs := tracks[i].scrofs-pbMain.Height div 16;
      end;
    end
  end;
  pbMain.Invalidate;
end;

procedure TForm1.btSaveClick(Sender: TObject);
var
  fname		: string;
  txt		: TextFile;
  ez		: integer;
  i			: integer;
  comptr	: integer;
  comlin	: integer;
  savdec	: char;

begin
  if dlgSave.Execute then begin;
    DoSaveFiles(dlgSave.FileName);
    fname := ChangeFileExt(dlgSave.FileName, '.csv');
    if FileExists(fname) then begin
      if FileExists(fname+'.bak') then SysUtils.DeleteFile(fname+'.bak');
      RenameFile(fname, fname+'.bak');
    end;
    AssignFile(txt, fname);
    rewrite(txt);
    // costruire intestazione
    fname := '';
    for ez := 1 to High(tracks) do with tracks[ez] do begin
      if comnum=0 then continue;
      if fname<>'' then fname := fname+#0;
      fname := fname+name;
    end;
    for ez := 1 to length(fname) do begin
      if fname[ez] in [' ', ',', ';', '-'] then fname[ez] := '_';
	  if fname[ez]=#0 then fname[ez] := ',';
    end;
    writeln(txt, fname);
    savdec := DecimalSeparator;
    DecimalSeparator := '.';

    ComPtr := 0;
    if comptr<CommLines.Count
      then comlin := integer(CommLines[comptr])
      else comlin := -1;

    for i := 1 to samples do begin
      fname := '';
      for ez := 1 to High(tracks) do with tracks[ez] do begin
        if comnum=0 then continue;
        if fname<>'' then fname := fname+',';
        fname := fname+format('%3.2f', [ data^[i] ]);
      end;
      // add comment, if any.
      if i=comlin then begin
        fname := fname+','+comments[comptr];
        inc(comptr);
        if comptr<CommLines.Count
          then comlin := integer(CommLines[comptr])
          else comlin := -1;
      end;

      writeln(txt, fname)
    end;
    DecimalSeparator := savdec;
    CloseFile(txt);
    datamodi := false;
  end;
end;

function TForm1.LoadFile(st: string): boolean;
var
  i,ez	: integer;
  k		: integer;
  txt	: TextFile;
  f		: string;
  savdec: char;

begin
  result := true;		// error
  mnClearClick(NIL);
  tmPoll.Enabled := false;
  ClosePorts;

  if DoLoadFiles(st)<>0 then begin
    // error
    Application.MessageBox(PChar('Error: can not open '+st),'XDatalog');
    exit
  end;

  cbTimebase.Enabled := false;
  for i := 0 to high(TimeBases) do if timebase=TimeBases[i]
    then cbTimebase.ItemIndex := i;

  // create buttons
  for i := 1 to high(tracks) do begin
    pnTrackBts.FindChildControl('bttr'+inttostr(i)).Free;
    pnTrackBts.FindChildControl('cktr'+inttostr(i)).Free;
    pnTrackBts.FindChildControl('rbtr'+inttostr(i)).Free;
    if tracks[i].comnum=0 then continue;
    CreateTRButton(i);
    TCheckBox( pnTrackBts.FindChildControl('cktr'+inttostr(i)) ).Color := tracks[i].scrcolor;
	TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(i)) ).Color := tracks[i].scrcolor;
  end;

  sbPaws.Down := true;
  tmPoll.Enabled := false;
  tbOffset.Position := 0;
  wasstopped := false;

  st := ChangeFileExt(st, '.csv');
  if not FileExists(st) then begin
    tbZoom.Position := tbZoom.max-5;
    exit
  end;

  AssignFile(txt, st );
  reset(txt);
  // read header
  readln(txt, st);

  // check number of samples
  samples := 0;
  locksamples := 0;
  while not eof(txt) do begin
    readln(txt, st);
    inc(samples)
  end;

  // alloc memory
  arylen := (samples div 4096 +1) * 4096;
  for ez := 1 to High(tracks) do with tracks[ez] do begin
    Getmem(data, arylen*sizeof(single));
    fillchar(data^, arylen*sizeof(single), 0);
  end;

  // caricare i dati
  Reset(txt);
  readln(txt, st);
  savdec := DecimalSeparator;
  DecimalSeparator := '.';
  for i := 1 to samples do begin
    if eof(txt) then break;
    readln(txt, st);
    if st='' then break;
    for ez := 1 to High(tracks) do with tracks[ez] do begin
      if comnum=0 then continue;
      k := pos(',', st);
      if k=0 then k := length(st)+1;
      f := copy(st,1,k-1);
      delete(st,1,k);
      data^[i] := StrToFloatDef(f, 0);
    end;
    // add comments if any
    if st<>'' then begin
      CommLines.add(pointer(i));
      comments.add(st);
    end
  end;
  DecimalSeparator := savdec;
  CloseFile(txt);

  if samples>0 then begin
    if pbMain.ClientWidth<samples
      then tbZoom.Position := trunc(pbMain.Width / samples * (tbZoom.Max-6))
      else tbZoom.Position := tbZoom.max-6+trunc(pbMain.Width/samples);
  end;
  result := false
end;

procedure TForm1.btLoadClick(Sender: TObject);
begin
  if dlgOpen.Execute then begin
    if datamodi then begin
      if Application.MessageBox('Unsaved data, really discard to load a new file?', PChar('Loading '+ExtractFileNameOnly(dlgOpen.FileName)), MB_YESNO or MB_DEFBUTTON2)<>IDYES then exit;
    end;

    if LoadFile(dlgOpen.FileName) then exit;
    dlgSave.FileName := dlgOpen.FileName;
    datamodi := false;
  end;
end;

procedure TForm1.btTrackMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  ez	: integer;

begin
  Handled := true;
  ez := TBitBtn(sender).tag;
  TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(ez)) ).Checked := true;
  if ssCtrl in Shift then begin
    if WheelDelta>0
      then tbTZoom.Position := tbTZoom.Position+2
      else tbTZoom.Position := tbTZoom.Position-2
  end else begin
    if WheelDelta>0
      then tbTOffset.Position := tbTOffset.Position+2
      else tbTOffset.Position := tbTOffset.Position-2
  end
end;

procedure TForm1.ckScrLockClick(Sender: TObject);
begin
  if ckScrLock.Checked then locksamples := samples;
end;

procedure TForm1.btCommentClick(Sender: TObject);
var
  st	: string;
  i		: integer;

begin
  st := InputBox('Add comment to data', 'Comment: ', '');
  if st='' then exit;
  CommLines.add(Pointer(samples));
  comments.add(st);
  datamodi := true
end;

function TForm1.CreateTRButton(ez: integer): TBitBtn;
var
  bt	: TBitBtn;
  ck	: TCheckBox;
  rb	: TRadioButton;

begin
  bt := TTrMyButton.Create(self);
  bt.Tag := ez;
  bt.name := 'bttr'+inttostr(ez);
  bt.Caption := tracks[ez].name;
  bt.Left := 6;
  bt.height := btAddTrack.height;
  bt.width  := btAddTrack.width-24;
  bt.top  := 8+(ez-1)*(4+btAddTrack.height);
  bt.Parent := pnTrackBts;
  bt.OnClick := @BtTrackClick;
  bt.OnMouseWheel := @btTrackMouseWheel;
  //
  rb := TRadioButton.Create(self);
  rb.top := bt.top+6;
  rb.left := bt.left+bt.width+8;
  rb.Checked := true;
  rb.Parent := pnTrackBts;
  rb.tag  := ez;
  rb.name := 'rbtr'+inttostr(ez);
  rb.Caption := '';
  rb.OnClick := @rbTrackSelClick;
  //
  ck := TCheckBox.Create(self);
  ck.top := bt.top+6;
  ck.left := rb.left+rb.width+8;
  ck.Checked := true;
  ck.Parent := pnTrackBts;
  ck.tag  := ez;
  ck.name := 'cktr'+inttostr(ez);
  ck.Caption := '';
  //
  result := bt
end;

procedure TForm1.btAddTrackClick(Sender: TObject);
var
  ez	: integer;
  bt	: TBitBtn;
  ck	: TCheckBox;

begin
  for ez := 1 to high(tracks) do begin
    if tracks[ez].comnum=0 then begin
      tracks[ez].comnum := 0;
  	  tracks[ez].name := 'New track';
      bt := CreateTRButton(ez);
      wasadding := true;
      BtTrackClick(bt);
      wasadding := false;
      exit
    end;
  end;
  Application.MessageBox('Can not add track: there are too many', 'XdataLogger');
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i		: integer;

begin
  FillChar(tracks, sizeof(tracks), 0);
  // non flickera... DoubleBuffered := true;
  DoubleBuffered := true;
  // flickera ugualmente: pbMain.controlstyle := pbMain.controlstyle + [csopaque];
  for i := 0 to high(TimeBases) do begin
    if TimeBases[i]<1000
      then cbTimebase.items.Add(inttostr(TimeBases[i])+' ms')
      else if TimeBases[i]<60000
        then cbTimebase.items.Add(format('%2.1f sec', [TimeBases[i] / 1000]))
        else cbTimebase.items.Add(format('%2.1f min', [TimeBases[i] / 60 / 60000]))
  end;
  cbTimebase.ItemIndex := 4;
  cbTimebaseSelect(NIL);

  comments  := TStringList.Create;
  CommLines	:= TList.Create;
end;

procedure TForm1.sbRunClick(Sender: TObject);
var
  i,k		: integer;

begin
  if not sbRun.Down then exit;
  lTime.Caption := 'Started on day '+FormatDateTime('d, hh:nn:ss', now);

  // aprire le porte
  OpenPorts;
  if portsopen then commerror := false;

  if wasstopped then mnClearClick(NIL);
  wasstopped := false;

  for i := 1 to high(tracks) do with tracks[i] do begin
    condcnt	 := 0;
    condison := false;
    if condONsam<>0 then condcnt := 4000
  end;

  tmPoll.Enabled := true;
  cbTimebase.Enabled := false;
end;

procedure TForm1.sbPawsClick(Sender: TObject);
begin
  tmPoll.Enabled := false;
  wasstopped := false;
end;

procedure TForm1.sbStopClick(Sender: TObject);
begin
  tmPoll.Enabled := false;
  cbTimebase.Enabled := true;
  wasstopped := true;
end;

procedure TForm1.tmPollTimer(Sender: TObject);
var
  ez		: integer;
  dat		: integer;

begin
  if not portsopen then begin
    commerror := true;
    exit
  end;
  inc(samples);
  datamodi := true;
  if samples>arylen then begin
    // allocare o riallocare memoria
    for ez := 1 to High(tracks) do begin
      if arylen=0
        then Getmem(tracks[ez].data, 4096*sizeof(single))
        else ReAllocMem(tracks[ez].data, (arylen+4096)*sizeof(single) );
    end;
	inc(arylen, 4096*sizeof(single))
  end;

  for ez := 1 to High(tracks) do with tracks[ez] do begin
    // first condition outputs
    if comnum>0 then if datid in [13..13+10-1] then if condONsam>0 then begin
      // yes, condition
      if condcnt>timebase then dec(condcnt, timebase) else begin
        // time expired
        if condison then begin
          condcnt := condONsam;
          if commandez(comport, ezredids[datid]+'=0') then commerror := true;
        end else begin
          condcnt := condOFsam;
          if datid in [13..13+8-1]
            then commandez(comport, ezredids[datid]+'=1')
            else commandez(comport, ezredids[datid]+'=116')
        end;
        condison := not condison;
      end
    end;

    if comnum>0 then if comport=NIL then commerror := true;
    data^[samples] := askez(comport, datid, ez, acqscale, acqoffs);
    // if tracks[ez].comnum<1 then continue;
    // if tracks[ez].comport=NIL then continue;
    // dat := askezred(ez);
    // tracks[ez].data^[samples] := dat*tracks[ez].acqscale + tracks[ez].acqoffs;
  end
end;

procedure TForm1.tmRefreshTimer(Sender: TObject);
var
  st	: string;
  rz	: single;
  sam	: single;

begin
  if samples=0 then st := 'No data' else begin
    if samples<5000
      then st := inttostr(samples)+' samples, '
      else st := format('%4.1fK samples, ', [samples/1000]);
    st := st+timedesc(samples*timebase)
  end;
  if commerror then st := st+' (ERR)';
  lSamples.Caption := st;
  if dlgOpen.filename<>'' then caption := ExtractFileNameOnly(dlgOpen.filename)+' - EZ-Red xDataLog';
  if ckScrLock.Checked then exit;

  if ckSmartSlide.Checked then begin
    if tbZoom.Position>=tbZoom.max-5
      then rz := pixxsampl[tbZoom.max-tbZoom.Position]
      else rz := tbZoom.Position / (tbZoom.max-5);

    // rz := rz+0.1;
    // I need samples*rz pixels
    sam := samples*rz+40;
    if sam<=pbMain.ClientWidth then begin
      // they fit in the window
      tbOffset.Position := 0
    end else begin
      // no, I must delete sam-width pixels
      sam := sam-pbMain.ClientWidth;
      sam := sam / rz;
      tbOffset.Position := round(sam/samples*1000);
    end;
  end;
  pbMain.Invalidate;
end;

var
  tbTrackChange	: boolean = false;


procedure TForm1.tbTZoomChange(Sender: TObject);
var
  ez	: integer;
  rb	: TRadioButton;

begin
  if tbTrackChange then exit;
  // trovare traccia attiva
  for ez := 1 to 16 do begin
    rb := TRadioButton( pnTrackBts.FindChildControl('rbtr'+inttostr(ez)) );
    if rb=NIL then continue;
    if not rb.Checked then continue;
    with tracks[ez] do begin
      if tbTZoom.Position>=tbTZoom.max-5 then begin
		scrzom := -pixxsampl[tbTZoom.max-tbTZoom.Position]; 	// zoom del display
        lTrZoom.Caption := format('%2.0fx', [-scrzom]);
      end else begin
        scrzom := -tbTZoom.Position / tbTZoom.max;
        lTrZoom.Caption := format('%2.0f%%', [ -scrzom*100 ]);
	  end;

      scrofs := pbMain.ClientHeight div 2 - 2*pbMain.Height*tbTOffset.Position div 128;		// offset del display
    end;
    pbMain.Invalidate;
    exit
  end;
end;

procedure TForm1.rbTrackSelClick(Sender: TObject);
var
  i		: integer;

begin
  tbTrackChange := true;
  with tracks[TRadioButton(sender).tag] do begin
    if scrzom>-1 then tbTZoom.Position := -round(tbTZoom.max*scrzom) else begin
      for i := 0 to high(pixxsampl)
		do if pixxsampl[i] = -round(scrzom)
          then tbTZoom.Position := tbTZoom.max-i
	end;
    tbTOffset.Position := (pbMain.ClientHeight div 2 - scrofs) * 128 div 2 div pbMain.Height;
  end;
  tbTrackChange := false
end;

procedure TForm1.tbZoomChange(Sender: TObject);
begin
  if tbZoom.Position>=tbZoom.max-5
    then lZoom.Caption := inttostr(pixxsampl[tbZoom.max-tbZoom.Position])+'x'
    else lZoom.Caption := format('%2.0f%%', [ tbZoom.Position / (tbZoom.max-5)*100 ]);
  pbMain.Invalidate;
end;

procedure TForm1.pbMainPaint(Sender: TObject);
var
  ez	: integer;
  z		: integer;		// zoom when >=1
  rz	: real;			// zoom when <1
  rz1	: real;
  maxl	: integer;
  cur	: integer;
  curx	: integer;
  vl	: single;
  vl2	: single;		// secondvl when zoom <1
  nvl	: single;
  ck	: TCheckBox;
  y1,y2	: integer;
  o1,o2	: integer;
  st	: string;
  lcksam: integer;

begin
  with pbMain.Canvas do begin
    Brush.Color := clBlack;
    FillRect(pbMain.ClientRect);
  end;
  if samples<1 then begin
    if showcross then if ocrossx>=0 then drawcursor;
    exit
  end;
  if ckScrLock.Checked
    then lcksam := locksamples
    else lcksam := samples;

  (* Ci sono due modi secondo lo zoom. Se i punti sono più grandi dei pixel,
    allora occorre disegnare linee; se sono più piccoli o uguali occorre
    un ciclo per sommare insieme i vari punti.

    Lo zoom massimo deve fare 8 pixel per sample, al minimo vediamo.
    Per max, 8 pix/s; max-1, 6 pix/s, max-2, 4 pix/s, max-3=3 pix/s, max-4=2 pix/s, max-5=1 pix/sam
  *)
  if tbZoom.Position>=tbZoom.max-5 then begin
    // multipixel per sample
    z := pixxsampl[tbZoom.max-tbZoom.Position];
    maxl := lcksam*tbOffset.Position div tbOffset.max;
    if maxl<1 then maxl := 1;

    // show comments, if any
    for cur := 0 to CommLines.Count-1 do begin
      y1 := integer(CommLines[cur]);
      if y1 < maxl then continue;	// too much to the left
      dec(y1, maxl);
      if y1 > z*pbMain.ClientWidth then continue;
      // yes, this comment lies inside the window
      y1 := y1*z;
      pbMain.Canvas.pen.Color := clGray;
      pbMain.Canvas.line(y1,0,y1,pbMain.ClientHeight)
    end;

    with pbMain.Canvas do for ez := 1 to high(tracks) do begin
      if tracks[ez].comnum=0 then continue;
      ck := TCheckBox( pnTrackBts.FindChildControl('cktr'+inttostr(ez)) );
      if ck=NIL then continue;
      if not ck.Checked then continue;

      pen.Color := tracks[ez].scrcolor;
      cur  := maxl;
      curx := 0;
      vl := tracks[ez].data^[cur];
      moveto(0, round( vl*tracks[ez].scrzom )+tracks[ez].scrofs);
      repeat
        inc(cur);
        if cur>lcksam then break;
        inc(curx, z);
        if curx>=pbMain.ClientWidth then break;
        vl := tracks[ez].data^[cur];
        lineto(curx, round( vl*tracks[ez].scrzom )+tracks[ez].scrofs);
      until false;
    end
  end else begin
    // Multisample per pixel
    rz := tbZoom.Position / (tbZoom.max-5);		// it's <1, like 0.8
    maxl := lcksam*tbOffset.Position div tbOffset.max;
    if maxl<1 then maxl := 1;

    // show comments, if any
    for cur := 0 to CommLines.Count-1 do begin
      y1 := integer(CommLines[cur]);
      if y1 < maxl then continue;	// too much to the left
      dec(y1, maxl);
      if y1*rz > pbMain.ClientWidth then continue;
      // yes, this comment lies inside the window
      y1 := round(y1*rz);
      pbMain.Canvas.pen.Color := clGray;
      pbMain.Canvas.line(y1,0,y1,pbMain.ClientHeight)
    end;

    with pbMain.Canvas do for ez := 1 to high(tracks) do begin
      if tracks[ez].comnum=0 then continue;
      ck := TCheckBox( pnTrackBts.FindChildControl('cktr'+inttostr(ez)) );
      if ck=NIL then continue;
      if not ck.Checked then continue;

      pen.Color := tracks[ez].scrcolor;
      cur  := maxl;
      curx := 0;
      rz1 := 0;
      o1 := 1; o2 := 0;
      repeat
        vl := tracks[ez].data^[cur];
        vl2 := vl;
        while rz1<1 do begin
          inc(cur);
          if cur>lcksam then break;
          rz1 := rz1+rz;
          nvl := tracks[ez].data^[cur];
          if nvl<vl then vl := nvl;
          if nvl>vl2 then vl2 := nvl;
        end;
        rz1 := rz1-1;

        y1 := round( vl*tracks[ez].scrzom )+tracks[ez].scrofs;
        y2 := round( vl2*tracks[ez].scrzom )+tracks[ez].scrofs;
        if y2=y1 then inc(y2);
        (*
          Old plot went from o1 to o2.
          If y1 >= o2, then do a line from o2 to y1.
          If y2 <= o1, the a line from o1 to y2.
        *)
        if o2>=o1 then begin
          if y1>o2 then line(curx-1, o2, curx, y1);
          if y2<o1 then line(curx-1, o1, curx, y2);
        end;
        line(curx, y1, curx, y2);
		o1 := y1;
        o2 := y2;

        inc(curx);
        if curx>=pbMain.ClientWidth then break;
        if cur>lcksam then break;
      until false
    end
  end;

  (*
    Trace time scale.
    Find the period of the whole screen. If timebase=50 and rz=0.5,
    every pixel spans 100 ms. Multiplied by the width, we have the time window in ms.
    The window must be divided in about 10 parts - find the nearest suitable value.
  *)
  // scale with time; use timebase/rz. Chose some unit a suitable timebase
  with pbMain.Canvas do begin
    if tbZoom.Position>=tbZoom.max-5
      then rz := pixxsampl[tbZoom.max-tbZoom.Position]
      else rz := tbZoom.Position / (tbZoom.max-5);

    pen.Color := clGray;
    o1 := pbMain.ClientHeight-8;
    line(0,o1, pbMain.ClientWidth, o1);

    // print starting time
    vl := lcksam*tbOffset.Position/tbOffset.max*timebase;
    st := timedesc(vl);
    (*
    o2 := trunc(vl/(24*60*60*1000)); // days
    st := format('%d days, %2.2f h', [o2, (vl-o2*24*60*60*1000) / 60 / 60 / 1000]);
    if vl<24*60*60*1000 then st := format('%2.2f h', [vl / 60 / 60 / 1000]);
    if vl<60*60*1000 then st := format('%2.2f m', [vl / 60 / 1000]);
    if vl<60*1000 then st := format('%2.2f s', [vl / 1000]);
    if vl<1000 then st := format('%d ms', [round(vl)]);
    *)
    TextOut(4, o1-22, ' < '+st);

    rz1 := timebase/rz*pbMain.ClientWidth;	// time covered by the window, in ms
    vl := rz1 / 25;	// time of 1/8 of the window, in ms
    curx := 4;

    // choose a tick unit and its width in nvl
    if vl<1000 then begin
      st := '1 s';
      nvl := 1000	// a mark will be 1 second
    end else if vl<5000 then begin
      st := '5 s';
      nvl := 5000
    end else if vl<10000 then begin
      st := '10 s';
      nvl := 10000
    end else if vl<20000 then begin
      st := '20 s';
      nvl := 20000
    end else if vl<60000 then begin
      st := '1 m';
      nvl := 60000
    end else if vl<300000 then begin
      st := '5 m';
      nvl := 300000
    end else if vl<600000 then begin
      st := '10 m';
      nvl := 600000
    end else if vl<1200000 then begin
      st := '20 m';
      nvl := 1200000
    end else if vl<3600000 then begin
      st := '1 h';
      nvl := 3600000
    end;
    // show the scale
    y1 := 150;
    y2 := y1 + round(nvl*rz / timebase);
    line(y1, o1-14, y2, o1-14);
    line(y1, o1-14-4, y1, o1-14+4);
    line(y2, o1-14-4, y2, o1-14+4);
    TextOut(y2+6, o1-22, ' = '+st);

    curx := 0;
    vl := 0;
    repeat
      vl := vl+nvl;
      curx := round(vl*rz / timebase);
      line(curx, o1-5, curx, o1);
    until curx >= pbMain.ClientWidth ;

    if showcross then if ocrossx>=0 then drawcursor;
  end;

end;


end.

